-- add support for taxes
CREATE TABLE tax (
	taxid BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL,
	name VARCHAR(15) NOT NULL,
	businessid BIGINT,
	PRIMARY KEY (taxid),
	CONSTRAINT fk_tax_businessid FOREIGN KEY (businessid) REFERENCES PUBLIC.business(businessid)	
);

CREATE TABLE taxgroup (
	taxgroupid BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL,
	name VARCHAR(15) NOT NULL,
	businessid BIGINT,
	PRIMARY KEY (taxgroupid),
	CONSTRAINT fk_taxgroup_businessid FOREIGN KEY (businessid) REFERENCES PUBLIC.business(businessid)	
);

CREATE TABLE taxrate (
	taxid BIGINT NOT NULL,
	expirydate TIMESTAMP,
	rate NUMERIC,
	serviceid BIGINT,
	CONSTRAINT fk_taxrate_serviceid FOREIGN KEY(serviceid) REFERENCES PUBLIC.service(serviceid),
	CONSTRAINT fk_taxrate_taxid FOREIGN KEY(taxid) REFERENCES PUBLIC.tax(taxid)
);

CREATE TABLE taxrule (
	taxgroupid BIGINT NOT NULL,
	additive BOOLEAN,
	taxid BIGINT,
	cumulatedtaxid BIGINT,
	CONSTRAINT fk_taxrule_taxgroupid FOREIGN KEY(taxgroupid) REFERENCES PUBLIC.taxgroup(taxgroupid),
	CONSTRAINT fk_taxrule_cumulatedtaxid FOREIGN KEY(cumulatedtaxid) REFERENCES PUBLIC.tax(taxid),
	CONSTRAINT fk_taxrule_taxid FOREIGN KEY(taxid) REFERENCES PUBLIC.tax(taxid)
);

ALTER TABLE invoice ADD taxgroupid BIGINT;
ALTER TABLE invoice ADD CONSTRAINT fk_invoice_taxgroupid FOREIGN KEY(taxgroupid) REFERENCES PUBLIC.taxgroup(taxgroupid);

ALTER TABLE client ADD taxnumber VARCHAR(30);
ALTER TABLE client ADD taxexempt BOOLEAN;
UPDATE client SET taxnumber='',taxexempt=FALSE;

ALTER TABLE business ADD taxnumber VARCHAR(30);
ALTER TABLE business ADD taxesenabled BOOLEAN;
UPDATE business SET taxnumber='',taxesenabled=FALSE;