-- new table to store time entries
CREATE TABLE timeentry (
	timeentryid BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL,
	date TIMESTAMP,
	elapsedtime BIGINT,
	description VARCHAR(50),
	itemid BIGINT,
	PRIMARY KEY (timeentryid),
	CONSTRAINT fk_timeentry_itemid FOREIGN KEY(itemid) REFERENCES item(itemid)
);

-- create a time entry for each item that has recorded time (elapsedtime > 0)
INSERT INTO timeentry(date,elapsedtime,description,itemid) SELECT item.date,item.elapsedtime,'',item.itemid FROM item WHERE item.elapsedtime > 0;
UPDATE item SET elapsedtime=NULL;