-- new table to hold the members of a project
CREATE TABLE projectmembership(
	projectmembershipid BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL,
	uuid VARCHAR(36) NOT NULL,
	journalentryid BIGINT,
	created TIMESTAMP NOT NULL,
	creatorid BIGINT,
	updated TIMESTAMP,
	projectid BIGINT,
	personid BIGINT,
	PRIMARY KEY(projectmembershipid),
	CONSTRAINT fk_projectmembership_creatorid FOREIGN KEY(creatorid) REFERENCES person(personid),
	CONSTRAINT fk_projectmembership_projectid FOREIGN KEY(projectid) REFERENCES project(projectid),
	CONSTRAINT fk_projectmembership_personid FOREIGN KEY(personid) REFERENCES person(personid)
);